#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

const int maxn = 1 << 17;

int n;
int x[maxn], y[maxn];
int L[maxn], R[maxn];
bool can[maxn];

double d(int i, int j) {
 	return sqrt(1.0 * (x[i] - x[j]) * (x[i] - x[j]) + 1.0 * (y[i] - y[j]) * (y[i] - y[j]));
}

int main() {
 	freopen("icebergs.in", "r", stdin);
	freopen("icebergs.out", "w", stdout);

	cin >> n;
	for (int i = 0; i < n; i++) {
	 	cin >> x[i] >> y[i];
	}

	double l = 0, r = 1e9;
	for (int it = 0; it < 60; it++) {
		double m = (l + r) / 2;
	 	int cur = 0;
		while (cur != n - 1) {
		    int nxt = cur;
			double mx = -acos(-1.0) / 2.0;
			for (int i = cur + 1; i < n; i++) {
			 	double ang = atan2((double)(y[i] - y[cur]), (double)(x[i] - x[cur]));
				if (ang > mx) {
				 	mx = ang;
					if (d(cur, i) < m) {
					 	nxt = i;
					}
				}
			}
			if (nxt == cur) break;
			cur = nxt;
		}
		if (cur == n - 1) r = m;
		else l = m;
	}    	
	cout.precision(10);
	cout << fixed;
	cout << r;

	return 0;
}